ALTER TABLE SBI_DATA_SOURCE ALTER COLUMN URL_CONNECTION VARCHAR(500);\p\g 

ALTER TABLE SBI_ALARM ALTER COLUMN LABEL VARCHAR(50) NOT NULL;
Create UNIQUE Index SBI_ALARM_label_unique  ON SBI_ALARM (LABEL )  ;\p\g

Create UNIQUE Index SBI_ALARM_CONTACT_name_unique  ON SBI_ALARM_CONTACT (NAME )  ;\p\g

/* start last edits*/

ALTER TABLE SBI_AUDIT ALTER COLUMN DOC_REF Integer;\p\g
ALTER TABLE SBI_AUDIT ALTER COLUMN ENGINE_REF Integer;\p\g
Create Index IDX_SBI_AUDIT_11  ON SBI_AUDIT (DOC_REF )  ;\p\g
Create Index IDX_SBI_AUDIT_22  ON SBI_AUDIT (ENGINE_REF )  ;\p\g

ALTER TABLE SBI_KPI_MODEL_INST ALTER COLUMN label VARCHAR(100) NOT NULL;\p\g
Create UNIQUE Index SBI_KPI_MODEL_INST_lbl_modinst  ON SBI_KPI_MODEL_INST (LABEL)  ;\p\g

ALTER TABLE SBI_KPI ALTER COLUMN code VARCHAR(40) NOT NULL;\p\g
Create UNIQUE Index SBI_KPI_code_unique  ON SBI_KPI (CODE)  ;\p\g

/* end last edits*/

Create UNIQUE Index SBI_KPI_MODEL_unique_kpi_model  ON SBI_KPI_MODEL (KPI_MODEL_CD )  ;\p\g

Create UNIQUE Index SBI_KPI_PERIOD_name_unique  ON SBI_KPI_PERIODICITY (name )  ;\p\g

ALTER TABLE SBI_THRESHOLD ALTER COLUMN code VARCHAR(45) NOT NULL;\p\g
Create UNIQUE Index SBI_THRESHOLD_code_unique  ON SBI_THRESHOLD (code )  ;\p\g

ALTER TABLE SBI_THRESHOLD_VALUE ALTER COLUMN label VARCHAR(20) NOT NULL;
Create UNIQUE Index SBI_THRESHOLD_VALUE_label_thId  ON SBI_THRESHOLD_VALUE (label, THRESHOLD_ID )  ;\p\g

Create UNIQUE Index SBI_RESOURCES_unique_res_name  ON SBI_RESOURCES (RESOURCE_NAME )  ;\p\g

ALTER TABLE SBI_KPI_MODEL ALTER COLUMN KPI_MODEL_CD VARCHAR(40) NOT NULL;\p\g

ALTER TABLE SBI_KPI_PERIODICITY ALTER COLUMN name VARCHAR(400) NOT NULL;\p\g

ALTER TABLE SBI_RESOURCES ALTER COLUMN RESOURCE_NAME VARCHAR(40) NOT NULL;\p\g

Create table SBI_EXPORTERS (
	ENGINE_ID Integer NOT NULL,
	DOMAIN_ID Integer NOT NULL,
	DEFAULT_VALUE Boolean,
	UNIQUE(ENGINE_ID, DOMAIN_ID)
Primary Key (ENGINE_ID,DOMAIN_ID)
) ;\p\g


ALTER TABLE SBI_EXPORTERS ADD CONSTRAINT FK_sbi_exporters_1 FOREIGN KEY ( DOMAIN_ID ) REFERENCES SBI_DOMAINS ( VALUE_ID );\p\g
ALTER TABLE SBI_EXPORTERS ADD CONSTRAINT FK_sbi_exporters_2 FOREIGN KEY ( ENGINE_ID ) REFERENCES SBI_ENGINES ( ENGINE_ID );\p\g


/*adds record for exporter functionality*/ 
Insert into SBI_DOMAINS (VALUE_CD,VALUE_NM,DOMAIN_CD,DOMAIN_NM,VALUE_DS) values ('PDF','PDF','EXPORT_TYPE','Exporters type','Exporters type');\p\g
Insert into SBI_DOMAINS (VALUE_CD,VALUE_NM,DOMAIN_CD,DOMAIN_NM,VALUE_DS) values ('XLS','XLS','EXPORT_TYPE','Exporters type','Exporters type');\p\g
Insert into SBI_DOMAINS (VALUE_CD,VALUE_NM,DOMAIN_CD,DOMAIN_NM,VALUE_DS) values ('JPG','JPG','EXPORT_TYPE','Exporters type','Exporters type');\p\g
Insert into SBI_DOMAINS (VALUE_CD,VALUE_NM,DOMAIN_CD,DOMAIN_NM,VALUE_DS) values ('PPT','PPT','EXPORT_TYPE','Exporters type','Exporters type');\p\g

commit;